﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin_count: ";
    cin >> in.bin_count;
    sort(begin(in.numbers), end(in.numbers));
    in.numbers.erase(unique(begin(in.numbers), end(in.numbers)), end(in.numbers));
    number_count = in.numbers.size();
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}

vector<size_t> 
make_histogram(const vector<double>& numbers, size_t& bin_count) {
    double min = 0;
    double max = 0;
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (double number : numbers) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= number) && (number < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

void
show_histogram_text(const vector<size_t>& bins, size_t& bin_count) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_count = 0;
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }
    double kof = double(MAX_ASTERISK) / max_count;
    if (kof > 1) {
        kof = 1;
    }
    for (size_t bin : bins) {
        if (bin < 100) {
            cout << " ";
        }
        if (bin < 10) {
            cout << " ";
        }
        cout << bin << "|";
        for (size_t i = 0; i < size_t(bin * kof); i++) {
            cout << "*";
        }
        cout << endl;
    }
}

int main() {
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);

}
       
       
    